#include "defines.h"
#include "serial.h"
#include "lib.h"

static int init(void)
{
  /* ȉ̓JEXNvgŒ`ĂV{ */
  extern int erodata, data_start, edata, bss_start, ebss;

  /*
   * f[^̈BSS̈D̏ȍ~łȂƁC
   * O[oϐĂȂ̂ŒӁD
   */
  memcpy(&data_start, &erodata, (char *)&edata - (char *)&data_start);
  memset(&bss_start, 0, (char *)&ebss - (char *)&bss_start);

  /* VȀ */
  serial_init(SERIAL_DEFAULT_DEVICE);

  return 0;
}

int global_data = 0x10;
int global_bss;
static int static_data = 0x20;
static int static_bss;

static void printval(void)
{
  puts("global_data = "); putxval(global_data, 0); puts("\n");
  puts("global_bss  = "); putxval(global_bss,  0); puts("\n");
  puts("static_data = "); putxval(static_data, 0); puts("\n");
  puts("static_bss  = "); putxval(static_bss,  0); puts("\n");
}

int main(void)
{
  init();
  puts("Hello World!\n");

  printval();
  puts("overwrite variables.\n");
  global_data = 0x20;
  global_bss  = 0x30;
  static_data = 0x40;
  static_bss  = 0x50;
  printval();

  while (1)
    ;

  return 0;
}
