#include "defines.h"
#include "kozos.h"
#include "interrupt.h"
#include "lib.h"

/* VXeE^XNƃ[UEXbh̋N */
static int start_threads(int argc, char *argv[])
{
  kz_run(consdrv_main, "consdrv",  1, 0x200, 0, NULL);
  kz_run(command_main, "command",  8, 0x200, 0, NULL);

  kz_chpri(15); /* DxāCAChXbhɈڍs */
  INTR_ENABLE; /* ݗLɂ */
  while (1) {
    asm volatile ("sleep"); /* ȓd̓[hɈڍs */
  }

  return 0;
}

int main(void)
{
  INTR_DISABLE; /* ݖɂ */

  puts("kozos boot succeed!\n");

  /* OS̓Jn */
  kz_start(start_threads, "idle", 0, 0x100, 0, NULL);
  /* ɂ͖߂ĂȂ */

  return 0;
}
