#include "defines.h"
#include "intr.h"
#include "interrupt.h"

/* \tgEGAE݃xN^̏ */
int softvec_init(void)
{
  int type;
  for (type = 0; type < SOFTVEC_TYPE_NUM; type++)
    softvec_setintr(type, NULL);
  return 0;
}

/* \tgEGAE݃xN^̐ݒ */
int softvec_setintr(softvec_type_t type, softvec_handler_t handler)
{
  SOFTVECS[type] = handler;
  return 0;
}

/*
 * ʊ݃nhD
 * \tgEGAE݃xN^āCenhɕ򂷂D
 */
void interrupt(softvec_type_t type, unsigned long sp)
{
  softvec_handler_t handler = SOFTVECS[type];
  if (handler)
    handler(type, sp);
}
